Subject: Re: git integration with monodevelop

From: Andreas Ericsson <[email-masked]>
Date: Thu, 13 Nov 2008 08:20:18 +0100

Evgeniy Ivanov wrote:
> Andreas Ericsson wrote:
>> Evgeniy Ivanov wrote:
>>> Hi Andreas,
>>> I've developed basic git-support in KDevelop using git's cmd-line
>>> interface. I'm very interested in rewriting it with libgit2, when
>>> libgit2 becomes usable. Can you, please, drop me a line, when you have
>>> some code?
>>>
>> git clone http://www.spearce.org/projects/scm/libgit2/libgit2.git
>>
>> will probably prove beneficial. I'm adding Shawn to Cc as he's the
>> primary libgit2 author. Please follow the git.git guidelines for
>> submitting patches, and please note that there's not much there
>> right now. Adding a wishlist for what you need in terms of UI
>> integration might make it easier to focus on something when it's
>> going slow.
>>
> 
> I can only suggest something like this on top of library (something like
>  common used things):
> http://websvn.kde.org/trunk/KDE/kdevplatform/plugins/git/gitexecutor.h?revision=856589&view=markup
> 
> I Don't think library interface should be much differ from cmd-line's one.

Well, it will be. The git CLI is inconsistent in places but it would be
weird to have libgit2 inherit those inconsistencies.

> For advanced use, QGit's includes can be used (search commit objects,
> etc). QGit has much more features, than my integration. AFAIK Shawn has
> experience in egit

Yes. He wrote it.

> (and maybe even gitk). IMHO the best thing is to
> implement libgit2 in terms of QGit, egit and maybe kdevelop's git
> support.

That would defeat the purpose rather wildly. The idea with libgit2 is
to create a library that the git cli can use, so building it based on
command-line output is a no-go. libgit2 is the attempt to make it right.

> I will help with pleasure (mentored by Shawn), when have some
> time (maybe only in January-February).
> 

Excellent :)

> But this is the same things Shawn has suggested to my mentor and me at
> the beginning of SoC...
>

Oh? I didn't know libgit2 started as a SoC project.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231